﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DevLeap.SP2010.SOAPClientDemo.sp2010.Lists;
using System.Xml.Linq;
using System.Xml;

namespace DevLeap.SP2010.SOAPClientDemo
{
    class Program
    {
        // Listing 5-28
        static void Main(string[] args)
        {
            String targetListName = "DevLeap Contacts";
            String baseUrl = "http://devbook.sp2010.local/_vti_bin/";

            Lists wsLists = new Lists();
            wsLists.Url = baseUrl + "Lists.asmx";
            wsLists.Credentials = System.Net.CredentialCache.DefaultCredentials;

            XElement listMetadata = XElement.Load(new XmlNodeReader(wsLists.GetList(targetListName)));
            
            
            Guid targetListId = new Guid(listMetadata.Attribute("ID").Value);
            XmlNode listItemsXmlNode = wsLists.GetListItems(
                targetListId.ToString(), // ID of the target list
                String.Empty, // ID of the view or String.Empty for default view
                null, // CAML query or null
                null, // ViewFields or null
                "200", // RowLimit as a string
                null, // Query options
                null // ID of the web site or null for root web site
                );

            XElement listItemsXml = XElement.Load(new XmlNodeReader(listItemsXmlNode));

            var xmlItems = from x in listItemsXml.Descendants("{#RowsetSchema}row")
                           select x;

            foreach (XElement xmlItem in xmlItems)
            {
                    Console.WriteLine("{0} - {1}",
                        xmlItem.Attribute("ows_ID").Value,
                        xmlItem.Attribute("ows_Title").Value);
            }
        }
    }
}
