﻿using System;
using System.ComponentModel;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using System.Xml;
using System.Xml.Xsl;
using System.Xml.XPath;
using System.IO;

namespace DevLeap.SP2010.AdvancedWebParts.RSSFeedViewerWebPart
{
    [ToolboxItemAttribute(false)]
    public class RSSFeedViewerWebPart : WebPart
    {
        [WebBrowsable(true)]
        [Personalizable(true)]
        public String RSSFeedUri { get; set; }

        [WebBrowsable(true)]
        [Personalizable(true)]
        public String XsltUri { get; set; }

        protected override void CreateChildControls()
        {
            if (this.WebPartManager.DisplayMode == WebPartManager.BrowseDisplayMode)
            {
                if (!String.IsNullOrEmpty(this.RSSFeedUri) && !String.IsNullOrEmpty(this.XsltUri))
                {
                    XslCompiledTransform xslt = new XslCompiledTransform();

                    SPFile xsltFile = SPContext.Current.Web.GetFile(this.XsltUri);
                    if (xsltFile != null)
                    {
                        xslt.Load(new XmlTextReader(xsltFile.OpenBinaryStream()));

                        XmlReader xml = XmlReader.Create(this.RSSFeedUri, new XmlReaderSettings
                        {
                            CloseInput = true,
                            ValidationType = System.Xml.ValidationType.None,
                            XmlResolver = new XmlUrlResolver()
                        });

                        using (xml)
                        {
                            StringWriter writer = new StringWriter();
                            xslt.Transform(xml, null, writer);

                            this.Controls.Add(new LiteralControl(writer.ToString()));
                        }
                    }
                    else
                    {
                        this.Controls.Add(new LiteralControl("Please provide a valid XSLT file URI in the current site."));
                    }
                }
                else
                {
                    this.Controls.Add(new LiteralControl("Please configure the Web Part."));
                }
            }
            else
            {
                this.Controls.Add(new LiteralControl("This Web Part renders its output only in browsing mode."));
            }
        }
    }
}
