<xsl:stylesheet xmlns:x="http://www.w3.org/2001/XMLSchema" xmlns:d="http://schemas.microsoft.com/sharepoint/dsp" version="1.0" exclude-result-prefixes="xsl msxsl ddwrt" xmlns:ddwrt="http://schemas.microsoft.com/WebParts/v2/DataView/runtime" xmlns:asp="http://schemas.microsoft.com/ASPNET/20" xmlns:__designer="http://schemas.microsoft.com/WebParts/v2/DataView/designer" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:msxsl="urn:schemas-microsoft-com:xslt" xmlns:SharePoint="Microsoft.SharePoint.WebControls" xmlns:ddwrt2="urn:frontpage:internal">
  <xsl:import href="/_layouts/xsl/main.xsl"/>

  <xsl:template match="View[@BaseViewID='2']" mode="full">
    <table width="100%" cellpadding="0" cellspacing="0" border="0">
      <tr>
        <td>
          <div>
            This is my custom view rendering template!
          </div>
          <div>
            <br/><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text><br/>
            Here is the View XML provided to the XSLT transformation:<br/>
            <textarea cols="80" rows="10">
              <xsl:copy-of select="/"/>
            </textarea>
          </div>
          <div>
            <br/><xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text><br/>
            Here are the Rows provided to the XSLT transformation:<br/>
            <textarea cols="80" rows="10">
              <xsl:copy-of select="$Rows"/>
            </textarea>
          </div>
        </td>
      </tr>
      <xsl:call-template name="CTXGeneration"/>
      <tr>
        <td>
          <xsl:if test="not($NoAJAX)">
            <iframe src="javascript:false;" id="FilterIframe{$ViewCounter}" name="FilterIframe{$ViewCounter}" style="display:none" height="0" width="0" FilterLink="{$FilterLink}"></iframe>
          </xsl:if>
          <table id="{$List}-{$View}" summary="{List/@title} {List/@description}" xmlns:o="urn:schemas-microsoft-com:office:office"
                 o:WebQuerySourceHref="{$HttpPath}&amp;XMLDATA=1&amp;RowLimit=0&amp;List={$List}&amp;View={$View}"
                 class="ms-summarystandardbody" width="100%" cellspacing="0" cellpadding="1" border="0" dir="{$XmlDefinition/List/@Direction}">
            <xsl:if test="not(List/@TemplateType='104' or List/@TemplateType='103' or List/@TemplateType='106')">
              <tr class="ms-viewheadertr" valign="TOP">
                <xsl:for-each select="ViewFields/FieldRef[not(@Explicit='TRUE')]">
                  <xsl:apply-templates mode="header" select="." />
                </xsl:for-each>
              </tr>
            </xsl:if>
            <xsl:choose>
              <xsl:when test="$dvt_RowCount != 0">
                <xsl:apply-templates select="." mode="RenderView" />
              </xsl:when>
              <xsl:otherwise>
                <!-- No list entries -->
                <xsl:call-template name="EmptyTemplate" />
                <tr>
                  <td height="5">
                    <img src="/_layouts/images/blank.gif" width="1" height="5" alt="" />
                  </td>
                </tr>
              </xsl:otherwise>
            </xsl:choose>
          </table>
          <script type='text/javascript'>
            <xsl:value-of select ="concat('HideListViewRows(&quot;', $List, '-', $View, '&quot;);')"/>
          </script>
        </td>
      </tr>
    </table>
    <xsl:apply-templates mode="footer" select="." />
  </xsl:template>

</xsl:stylesheet>
