﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.UI;
using Microsoft.SharePoint.WebControls;
using System.Web.UI.WebControls;
using Microsoft.SharePoint;

namespace DevLeap.SP2010.CustomFields
{
    public class IBANFieldEditor: UserControl, IFieldEditor
    {
        private IBANField _IBANField;
        protected DropDownList banksLookupList;

        public bool DisplayAsNewSection
        {
            get { return(false); }
        }

        public void InitializeWithField(Microsoft.SharePoint.SPField field)
        {
            this._IBANField = field as IBANField;

            if (!Page.IsPostBack)
            {
                BindLookupList();

                if ((this._IBANField != null) && (this._IBANField.BanksListID != Guid.Empty))
                {
                    var item = this.banksLookupList.Items.FindByValue(this._IBANField.BanksListID.ToString());
                    if (item != null)
                    {
                        this.banksLookupList.ClearSelection();
                        item.Selected = true;
                    }
                }
            }
        }

        public void OnSaveChange(Microsoft.SharePoint.SPField field, bool isNewField)
        {
            IBANField targetField = field as IBANField;
            if (targetField != null)
            {
                targetField.BanksListID = new Guid(this.banksLookupList.SelectedValue);
            }
        }

        private void BindLookupList()
        {
            SPWeb web = SPContext.Current.Web;

            foreach (SPList list in web.Lists)
            {
                this.banksLookupList.Items.Add(new ListItem(list.Title, list.ID.ToString()));
            }
        }
    }
}
