﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.SharePoint;
using Microsoft.Office.DocumentManagement.DocumentSets;
using System.IO;

namespace DevLeap.SP2010.ExportDocumentSet
{
    class Program
    {
        static void Main(string[] args)
        {
            using (SPSite site = new SPSite("http://devbook.sp2010.local/"))
            {
                using (SPWeb web = site.OpenWeb())
                {
                    SPList library = web.Lists["Work Orders"];

                    // Search for items of type Document Set
                    foreach (SPListItem item in library.Items)
                    {
                        // In case the ContentTypeId of the item inherits from a DocumentSet
                        if (DocumentSetTemplate.Id.IsParentOf(item.ContentTypeId))
                        {
                            // Get a reference to the DocumentSet instance
                            DocumentSet ds = DocumentSet.GetDocumentSet(item.Folder);
                            // Export the item as a .ZIP content
                            Byte[] package = ds.Export();

                            using (FileStream fs = new FileStream(ds.Item.Title + ".zip", FileMode.CreateNew, FileAccess.Write, FileShare.None))
                            {
                                using(BinaryWriter bw = new BinaryWriter(fs))
                                {
                                    bw.Write(package);
                                    bw.Flush();
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}
