﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Office.DocumentManagement;
using Microsoft.SharePoint;

namespace DevLeap.SP2010.SampleDocumentIDProvider
{
    public class GuidDocumentIdProvider : DocumentIdProvider
    {
        public override bool DoCustomSearchBeforeDefaultSearch
        {
            get { return(false); }
        }

        public override string GenerateDocumentId(Microsoft.SharePoint.SPListItem listItem)
        {
            return(String.Format("ID{0}", Guid.NewGuid().ToString("N")));
        }

        public override string[] GetDocumentUrlsById(Microsoft.SharePoint.SPSite site, string documentId)
        {
            List<String> urls = new List<string>();

            foreach (SPWeb web in site.AllWebs)
            {
                using (web)
                {
                    foreach (SPList list in web.Lists)
                    {
                        SPDocumentLibrary library = list as SPDocumentLibrary;
                        if (library != null)
                        {
                            foreach (SPListItem item in library.Items)
                            {
                                try
                                {
                                    if ((String)item["Document ID"] == documentId)
                                    {
                                        urls.Add(String.Format("{0}/{1}", web.Url, item.Url));
                                    }
                                }
                                catch (ArgumentException)
                                {
                                    // Invalid field
                                }
                            }
                        }
                    }
                }
            }

            return (urls.ToArray());
        }

        public override string GetSampleDocumentIdText(Microsoft.SharePoint.SPSite site)
        {
            return (String.Format("ID{0}", Guid.NewGuid().ToString("N")));
        }
    }
}
