﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.SharePoint.Administration;
using Microsoft.SharePoint;

namespace DevLeap.SP2010.ProtocolServiceApp
{
    [System.Runtime.InteropServices.Guid("FF04F201-B0E8-4dd7-A3ED-C435B3AC9B37")]
    public class ProtocolServiceApplicationProxy : SPIisWebServiceApplicationProxy
    {
        private ProtocolServiceApplication _applicationInstance;
        private Object _applicationInstanceSyncLock = new Object();

        // An empty public constructor required for serialization.
        public ProtocolServiceApplicationProxy() 
        {
        }

        public ProtocolServiceApplicationProxy(string name, SPIisWebServiceProxy serviceProxy, Uri serviceEndpointUri)
            : base(name, serviceProxy, serviceEndpointUri)
        {

        }

        internal ProtocolServiceApplicationProxy(string name, SPIisWebServiceProxy serviceProxy, ProtocolServiceApplication serviceApplication)
            : base(name, serviceProxy, serviceApplication.Uri)
        {
            this._applicationInstance = serviceApplication;
        }

        public ProtocolServiceApplication ProtocolServiceApplication
        {
            get
            {
                ProtocolServiceApplication application = this._applicationInstance;
                if (this._applicationInstance == null)
                {
                    lock (this._applicationInstanceSyncLock)
                    {
                        if (this._applicationInstance == null)
                        {
                            this._applicationInstance = ProtocolService.CurrentInstance.Applications.GetValue<ProtocolServiceApplication>(this.Name);
                            if (this._applicationInstance == null)
                                throw new ApplicationException("Protocol Service application is not currently available.");
                        }
                    }
                }

                return this._applicationInstance;
            }
        }

        public static ProtocolServiceApplicationProxy GetProxy(SPServiceContext serviceContext)
        {
            if (serviceContext == null)
            {
                throw new ArgumentNullException("serviceContext");
            }
            return (serviceContext.GetDefaultProxy(typeof(ProtocolServiceApplicationProxy)) as ProtocolServiceApplicationProxy);
        }    
    }
}
