﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.SharePoint.Administration;
using Microsoft.SharePoint.Utilities;
using System.Security.Principal;

namespace DevLeap.SP2010.ProtocolServiceApp
{
    [System.Runtime.InteropServices.Guid("139CA8FC-0AAA-4599-AC86-21E9D62A3BD7")]
    internal sealed class ProtocolServiceDatabase: SPDatabase
    {
        #region Constructors

        public ProtocolServiceDatabase()
            : base()
        { }

        internal ProtocolServiceDatabase(SPDatabaseParameters parameters)
            : base (parameters)
        {
            this.Status = SPObjectStatus.Disabled;
        }

        #endregion

        #region SPDatabase

        public override void Provision()
        {
            if (this.Status == SPObjectStatus.Online)
                return;

            this.Status = SPObjectStatus.Provisioning;
            this.Update();

            Dictionary<String, Boolean> options = new Dictionary<string, bool>(1);
            options.Add(SqlDatabaseOption[(int)DatabaseOptions.AutoClose], false);

            SPDatabase.Provision(
                this.DatabaseConnectionString,
                SPUtility.GetGenericSetupPath(@"Template\SQL\ProtocolServiceApplication.sql"),
                options);

            this.Status = SPObjectStatus.Online;
            this.Update();
        }

        public override void Unprovision()
        {
            base.Unprovision();
        }

        #endregion

        #region Internal methods

        internal void GrantApplicationPoolAccess(SecurityIdentifier processSecurityIdentifier)
        {
            this.GrantAccess(processSecurityIdentifier, "db_owner");
        }

        #endregion
    }
}
