﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.SharePoint.Administration;

namespace DevLeap.SP2010.ProtocolServiceApp
{
    [System.Runtime.InteropServices.Guid("730A7373-98F6-4947-B72D-CD07D09D0A4B")]
    [SupportedServiceApplication("FF04F201-B0E8-4dd7-A3ED-C435B3AC9B37",
        "1.0.0.0", typeof(ProtocolServiceApplicationProxy))]
    public class ProtocolServiceProxy : SPIisWebServiceProxy, IServiceProxyAdministration
    {
        public ProtocolServiceProxy() 
        {
        }

        internal ProtocolServiceProxy(SPFarm farm)
            : base(farm)
        {
        }

        public SPServiceApplicationProxy CreateProxy(Type serviceApplicationProxyType, string name, Uri serviceApplicationUri, SPServiceProvisioningContext provisioningContext)
        {
            if (serviceApplicationProxyType != typeof(ProtocolServiceApplicationProxy))
            {
                throw new NotSupportedException("Invalid ServiceApplicationProxyType");
            }

            return new ProtocolServiceApplicationProxy(name, this, serviceApplicationUri);
        }

        public SPPersistedTypeDescription GetProxyTypeDescription(Type serviceApplicationProxyType)
        {
            return new SPPersistedTypeDescription(
                "Protocol Service Proxy",
                "Proxies to the Protocol Service.");
        }

        public Type[] GetProxyTypes()
        {
            return new Type[] { typeof(ProtocolServiceApplicationProxy) };
        }
    }
}
