﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Management.Automation;
using Microsoft.SharePoint.PowerShell;
using Microsoft.SharePoint.Administration;

namespace DevLeap.SP2010.ProtocolServiceAppProxy.PowerShellRegistration
{
    [Cmdlet(VerbsLifecycle.Install, "ProtocolServiceProxy", SupportsShouldProcess = true)]
    internal sealed class InstallProtocolServiceProxy : SPCmdlet
    {
        protected override bool RequireUserFarmAdmin()
        {
            return true;
        }

        protected override void InternalProcessRecord()
        {
            // Ensure that the required local farm object is available
            SPFarm farm = SPFarm.Local;
            if (null == farm)
            {
                ThrowTerminatingError(new InvalidOperationException("SharePoint server farm not found."),
                    ErrorCategory.ResourceUnavailable, this);
            }

            if (ShouldProcess("Sample Web Service Proxy"))
            {
                // Ensure that the sample web service proxy exists
                ProtocolServiceProxy serviceProxy = farm.ServiceProxies.GetValue<ProtocolServiceProxy>();
                if (null == serviceProxy)
                {
                    // Create the service proxy
                    serviceProxy = new ProtocolServiceProxy(farm);
                    serviceProxy.Update(true);
                }
            }
        }
    }
}
