﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.SharePoint;

namespace DevLeap.SP2010.ProtocolServiceAppProxy
{
    [Flags]
    public enum ExecuteOptions
    {
        None = 0x0,
        AsProcess = 0x1,
        // Async = 0x2,
    }

    public sealed class ProtocolServiceClient
    {
        private SPServiceContext _serviceContext;

        public ProtocolServiceClient(SPServiceContext serviceContext)
        {
            if (serviceContext == null)
                throw new ArgumentNullException("serviceContext");

            this._serviceContext = serviceContext;
        }

        public String GenerateProtocolNumber(String contentUri, ExecuteOptions options)
        {
            String result = String.Empty;
            ProtocolServiceApplicationProxy.Invoke(_serviceContext, proxy => result = proxy.GenerateProtocolNumber(contentUri, options));
            return (result);
        }
    }
}
