﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.SharePoint.Administration;

namespace DevLeap.SP2010.ProtocolServiceAppProxy
{
    [System.Runtime.InteropServices.Guid("0DDA776A-932B-45d0-8330-70C022CFEEAF")]
    [SupportedServiceApplication("C7E904DA-9DF0-4038-9806-025EEA58C437", "1.0.0.0", typeof(ProtocolServiceApplicationProxy))]
    public sealed class ProtocolServiceProxy : SPIisWebServiceProxy, IServiceProxyAdministration
    {
        #region Constructors

        public ProtocolServiceProxy()
            : base()
        { }

        public ProtocolServiceProxy(SPFarm farm)
            : base(farm)
        { }

        #endregion

        #region IServiceProxyAdministration

        public SPServiceApplicationProxy CreateProxy(Type serviceApplicationProxyType, string name, Uri serviceApplicationUri, SPServiceProvisioningContext provisioningContext)
        {
            if (serviceApplicationProxyType != typeof(ProtocolServiceApplicationProxy))
                throw new NotSupportedException("Invalid Service Application type, expected ProtocolServiceApplicationProxy");

            return new ProtocolServiceApplicationProxy(name, this, serviceApplicationUri);
        }

        public SPPersistedTypeDescription GetProxyTypeDescription(Type serviceApplicationProxyType)
        {
            return new SPPersistedTypeDescription("Protocol Service Proxy", 
                "Connects to the Protocol Service.");
        }

        public Type[] GetProxyTypes()
        {
            return new Type[] { typeof(ProtocolServiceApplicationProxy) };
        }

        #endregion
    }
}
