﻿using System;
using System.ComponentModel;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using DevLeap.SP2010.ProtocolServiceAppProxy;

namespace DevLeap.SP2010.ProtocolServiceConsumer
{
    [ToolboxItemAttribute(false)]
    public class ProtocolServiceWebPart : WebPart
    {
        protected Label contentUriLabel;
        protected TextBox contentUri;
        protected Button getProtocolNumber;
        protected Label result;

        protected override void CreateChildControls()
        {
            this.contentUriLabel = new Label();
            this.contentUriLabel.Text = "Content URI:";
            this.Controls.Add(this.contentUriLabel);

            this.contentUri = new TextBox();
            this.contentUri.Width = Unit.Pixel(200);
            this.Controls.Add(this.contentUri);

            this.Controls.Add(new LiteralControl("<br>"));

            this.getProtocolNumber = new Button();
            this.getProtocolNumber.Text = "Get Protocol Number!";
            this.getProtocolNumber.Click += new EventHandler(getProtocolNumber_Click);
            this.Controls.Add(this.getProtocolNumber);

            this.result = new Label();
            this.Controls.Add(this.result);
        }

        void getProtocolNumber_Click(object sender, EventArgs e)
        {
            ProtocolServiceClient psc = new ProtocolServiceClient(SPServiceContext.Current);

            this.result.Text = psc.GenerateProtocolNumber(this.contentUri.Text, ExecuteOptions.None);
        }
    }
}
