$sampleApp = Get-SPServiceApplication | where { $_.GetType().FullName -eq "DevLeap.SP2010.ProtocolServiceApp.ProtocolServiceApplication" -and $_.Name -eq "ProtocolServiceApplicationOne" }
if ($sampleApp -eq $null)
{
    $sampleApp = New-ProtocolServiceApplication -Name ProtocolServiceApplicationOne -ApplicationPool "SharePoint Web Services System" 

    $user = $env:userdomain + '\' + $env:username
    $userClaim = New-SPClaimsPrincipal -Identity $user -IdentityType WindowsSamAccountName
    $security = Get-SPServiceApplicationSecurity $sampleApp
    Grant-SPObjectSecurity $security $userClaim -Rights "Full Control"
    Set-SPServiceApplicationSecurity $sampleApp $security
}
$sampleAppProxy = Get-SPServiceApplicationProxy | where { $_.GetType().FullName -eq "DevLeap.SP2010.ProtocolServiceAppProxy.ProtocolServiceApplicationProxy" -and $_.Name -eq "ProtocolServiceApplicationProxyOne" }
if ($sampleAppProxy -eq $null)
{
    $sampleAppProxy = New-ProtocolServiceApplicationProxy -Name ProtocolServiceApplicationProxyOne -ServiceApplication $sampleApp
    Get-SPServiceApplicationProxyGroup -Default | Add-SPServiceApplicationProxyGroupMember -Member $sampleAppProxy
}
$localServiceInstance = Get-SPServiceInstance -Server $env:computername | where { $_.GetType().FullName -eq "DevLeap.SP2010.ProtocolServiceApp.ProtocolServiceInstance" -and $_.Name -eq "" }
if ($localServiceInstance.Status -ne 'Online')
{
    Start-SPServiceInstance $localServiceInstance
}