﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Workflow;
using Microsoft.SharePoint.WorkflowActions;

namespace DevLeap.SP2010.SampleApprovalWorkflow
{
    public sealed partial class ApprovalWorkflow : SequentialWorkflowActivity
    {
        public ApprovalWorkflow()
        {
            InitializeComponent();
        }

        public Guid workflowId = default(System.Guid);
        public SPWorkflowActivationProperties workflowProperties =
            new SPWorkflowActivationProperties();
        public static DependencyProperty ApprovalTaskIdProperty = DependencyProperty.Register("ApprovalTaskId", typeof(System.Guid), typeof(DevLeap.SP2010.SampleApprovalWorkflow.ApprovalWorkflow));

        private void onWorkflowActivated_Invoked(object sender, ExternalDataEventArgs e)
        {
            // Here you could write some initialization code
        }

        [DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)]
        [BrowsableAttribute(true)]
        [CategoryAttribute("Misc")]
        public Guid ApprovalTaskId
        {
            get
            {
                return ((System.Guid)(base.GetValue(DevLeap.SP2010.SampleApprovalWorkflow.ApprovalWorkflow.ApprovalTaskIdProperty)));
            }
            set
            {
                base.SetValue(DevLeap.SP2010.SampleApprovalWorkflow.ApprovalWorkflow.ApprovalTaskIdProperty, value);
            }
        }

        public static DependencyProperty ApprovalTaskPropertiesProperty = DependencyProperty.Register("ApprovalTaskProperties", typeof(Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties), typeof(DevLeap.SP2010.SampleApprovalWorkflow.ApprovalWorkflow));

        [DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)]
        [BrowsableAttribute(true)]
        [CategoryAttribute("Misc")]
        public SPWorkflowTaskProperties ApprovalTaskProperties
        {
            get
            {
                return ((Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties)(base.GetValue(DevLeap.SP2010.SampleApprovalWorkflow.ApprovalWorkflow.ApprovalTaskPropertiesProperty)));
            }
            set
            {
                base.SetValue(DevLeap.SP2010.SampleApprovalWorkflow.ApprovalWorkflow.ApprovalTaskPropertiesProperty, value);
            }
        }

        private void createApprovalTask_MethodInvoking(object sender, EventArgs e)
        {
            // Assign a unique ID to the ApprovalTask
            this.ApprovalTaskId = Guid.NewGuid();

            // Configure the properties of the ApprovalTask
            this.ApprovalTaskProperties = new SPWorkflowTaskProperties();
            this.ApprovalTaskProperties.AssignedTo = "SP2010DEV\\DemoUser";
            this.ApprovalTaskProperties.Description = "Please approve this offer";
            this.ApprovalTaskProperties.DueDate = DateTime.Now.AddDays(10);
            this.ApprovalTaskProperties.SendEmailNotification = true;
            this.ApprovalTaskProperties.Title = "Please approve this offer";
        }

        private void waitForOutcome(object sender, ConditionalEventArgs e)
        {
            // This method is invoked for every loop of the While activity
            e.Result = repeatWhile;
        }

        public Boolean repeatWhile = true;
        public String currentModerationStatusText;

        private void onOfferItemChanged_Invoked(object sender, ExternalDataEventArgs e)
        {
            this.currentModerationStatusText = SPFieldModStat.TextFieldValueFromValue(this.workflowProperties.Item[FieldsIds.ModerationStatusFieldId]);

            if ((this.currentModerationStatusText == "Approved") ||
                (this.currentModerationStatusText == "Rejected"))
            {
                this.repeatWhile = false;
            }
            else
            {
                this.repeatWhile = false;
            }
        }
    }
}
