﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.SharePoint.WorkflowActions;
using Microsoft.SharePoint;

namespace DevLeap.SP2010.Activities
{
    public class DevLeapConditions
    {
        public static Boolean IsCheckedOutByUser(WorkflowContext context, 
            String listId, Int32 itemId, String loginName)
        {
            // Retrieve the current web
            using (SPWeb web = context.Web)
            {
                // Retrive the current list instance
                SPList list = web.Lists[Helper.GetListGuid(context, listId)];

                // Retrieve the single item
                SPListItem item = list.GetItemById(itemId);

                // Check if it is checked-out by that specific loginName
                if ((item.File.CheckOutType != SPFile.SPCheckOutType.None)
                    && item.File.CheckedOutByUser.LoginName == loginName)
                    return (true);
                else
                    return (false);
            }
        }

        public static Boolean FileNameExtension(WorkflowContext context,
            String listId, Int32 itemId, String extension)
        {
            // Retrieve the current web
            using (SPWeb web = context.Web)
            {
                // Retrive the current list instance
                SPList list = web.Lists[Helper.GetListGuid(context, listId)];

                // Retrieve the single item
                SPListItem item = list.GetItemById(itemId);

                // Check if it is checked-out by that specific loginName
                if (item.File.Name.ToUpper().EndsWith(extension))
                    return (true);
                else
                    return (false);
            }
        }
    }
}
