﻿using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Linq;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Workflow;
using Microsoft.SharePoint.WorkflowActions;

namespace DevLeap.SP2010.CRMOffersApproval.CRMOffersApprovalWorkflow
{
    public sealed partial class CRMOffersApprovalWorkflow : SequentialWorkflowActivity
    {
        public CRMOffersApprovalWorkflow()
        {
            InitializeComponent();
        }

        public Guid workflowId = default(System.Guid);
        public SPWorkflowActivationProperties workflowProperties = new SPWorkflowActivationProperties();

        public CRMAssociationDataConfiguration AssociationData;
        public CRMInitiationDataConfiguration InitiationData;

        public static DependencyProperty ApprovalTaskIdProperty = DependencyProperty.Register("ApprovalTaskId", typeof(System.Guid), typeof(DevLeap.SP2010.CRMOffersApproval.CRMOffersApprovalWorkflow.CRMOffersApprovalWorkflow));

        [DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)]
        [BrowsableAttribute(true)]
        [CategoryAttribute("Misc")]
        public Guid ApprovalTaskId
        {
            get
            {
                return ((System.Guid)(base.GetValue(DevLeap.SP2010.CRMOffersApproval.CRMOffersApprovalWorkflow.CRMOffersApprovalWorkflow.ApprovalTaskIdProperty)));
            }
            set
            {
                base.SetValue(DevLeap.SP2010.CRMOffersApproval.CRMOffersApprovalWorkflow.CRMOffersApprovalWorkflow.ApprovalTaskIdProperty, value);
            }
        }

        public static DependencyProperty ApprovalTaskPropertiesProperty = DependencyProperty.Register("ApprovalTaskProperties", typeof(Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties), typeof(DevLeap.SP2010.CRMOffersApproval.CRMOffersApprovalWorkflow.CRMOffersApprovalWorkflow));

        [DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)]
        [BrowsableAttribute(true)]
        [CategoryAttribute("Misc")]
        public SPWorkflowTaskProperties ApprovalTaskProperties
        {
            get
            {
                return ((Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties)(base.GetValue(DevLeap.SP2010.CRMOffersApproval.CRMOffersApprovalWorkflow.CRMOffersApprovalWorkflow.ApprovalTaskPropertiesProperty)));
            }
            set
            {
                base.SetValue(DevLeap.SP2010.CRMOffersApproval.CRMOffersApprovalWorkflow.CRMOffersApprovalWorkflow.ApprovalTaskPropertiesProperty, value);
            }
        }

        public static DependencyProperty ApprovalTaskAfterPropertiesProperty = DependencyProperty.Register("ApprovalTaskAfterProperties", typeof(Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties), typeof(DevLeap.SP2010.CRMOffersApproval.CRMOffersApprovalWorkflow.CRMOffersApprovalWorkflow));

        [DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)]
        [BrowsableAttribute(true)]
        [CategoryAttribute("Misc")]
        public SPWorkflowTaskProperties ApprovalTaskAfterProperties
        {
            get
            {
                return ((Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties)(base.GetValue(DevLeap.SP2010.CRMOffersApproval.CRMOffersApprovalWorkflow.CRMOffersApprovalWorkflow.ApprovalTaskAfterPropertiesProperty)));
            }
            set
            {
                base.SetValue(DevLeap.SP2010.CRMOffersApproval.CRMOffersApprovalWorkflow.CRMOffersApprovalWorkflow.ApprovalTaskAfterPropertiesProperty, value);
            }
        }

        public static DependencyProperty ApprovalTaskBeforePropertiesProperty = DependencyProperty.Register("ApprovalTaskBeforeProperties", typeof(Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties), typeof(DevLeap.SP2010.CRMOffersApproval.CRMOffersApprovalWorkflow.CRMOffersApprovalWorkflow));

        [DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)]
        [BrowsableAttribute(true)]
        [CategoryAttribute("Misc")]
        public SPWorkflowTaskProperties ApprovalTaskBeforeProperties
        {
            get
            {
                return ((Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties)(base.GetValue(DevLeap.SP2010.CRMOffersApproval.CRMOffersApprovalWorkflow.CRMOffersApprovalWorkflow.ApprovalTaskBeforePropertiesProperty)));
            }
            set
            {
                base.SetValue(DevLeap.SP2010.CRMOffersApproval.CRMOffersApprovalWorkflow.CRMOffersApprovalWorkflow.ApprovalTaskBeforePropertiesProperty, value);
            }
        }

        public static DependencyProperty ApprovalTaskOutcomeProperty = DependencyProperty.Register("ApprovalTaskOutcome", typeof(System.String), typeof(DevLeap.SP2010.CRMOffersApproval.CRMOffersApprovalWorkflow.CRMOffersApprovalWorkflow));

        [DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)]
        [BrowsableAttribute(true)]
        [CategoryAttribute("Misc")]
        public String ApprovalTaskOutcome
        {
            get
            {
                return ((string)(base.GetValue(DevLeap.SP2010.CRMOffersApproval.CRMOffersApprovalWorkflow.CRMOffersApprovalWorkflow.ApprovalTaskOutcomeProperty)));
            }
            set
            {
                base.SetValue(DevLeap.SP2010.CRMOffersApproval.CRMOffersApprovalWorkflow.CRMOffersApprovalWorkflow.ApprovalTaskOutcomeProperty, value);
            }
        }

        private void checkOfferEuroAmount(object sender, ConditionalEventArgs e)
        {
            // Extract the OfferEuroAmount field from the target of invokation
            Decimal offerEuroAmount = (Decimal)((Double)this.workflowProperties.Item[FieldsIds.DevLeapCRMOfferEuroAmount_Id]);

            // Check if the OfferEuroAmount exceeds the limit
            e.Result = (offerEuroAmount >= this.AssociationData.OfferEuroAmountLimit);
        }

        private void whileApprovalTaskNotCompleted(object sender, ConditionalEventArgs e)
        {
            // This method is invoked for every loop of the While activity
            e.Result = !taskCompleted;
        }

        private void onApprovalTaskChanged_Invoked(object sender, ExternalDataEventArgs e)
        {
            this.ApprovalTaskOutcome = this.ApprovalTaskAfterProperties.ExtendedProperties[FieldsIds.DevLeapCRMApprovalTaskOutcome_Id].ToString();
            if (this.ApprovalTaskOutcome.Equals("Approved") || this.ApprovalTaskOutcome.Equals("Rejected"))
                this.taskCompleted = true;
            else
                this.taskCompleted = false;
        }

        public Boolean taskCompleted = false;

        private void onWorkflowActivated_Invoked(object sender, ExternalDataEventArgs e)
        {
            // Retrieve the current AssociationData configuration
            this.AssociationData = WorkflowUtility.DeserializeData<CRMAssociationDataConfiguration>(this.workflowProperties.AssociationData);
            // Check if there is also the InitiationData configuration
            if (!String.IsNullOrEmpty(this.workflowProperties.InitiationData))
                this.InitiationData = WorkflowUtility.DeserializeData<CRMInitiationDataConfiguration>(this.workflowProperties.InitiationData);
        }

        private void createApprovalTask_MethodInvoking(object sender, EventArgs e)
        {
            // Assign a unique ID to the ApprovalTask
            this.ApprovalTaskId = Guid.NewGuid();

            // Configure the properties of the ApprovalTask
            this.ApprovalTaskProperties = new SPWorkflowTaskProperties();

            this.ApprovalTaskProperties.AssignedTo = ((this.InitiationData != null) &&
                !String.IsNullOrEmpty(this.InitiationData.OfferManager)) ?
                this.InitiationData.OfferManager : this.AssociationData.OfferManager;
            if ((this.InitiationData != null) &&
                !String.IsNullOrEmpty(this.InitiationData.ApprovalRequestNotes))
            {
                this.ApprovalTaskProperties.Description = this.InitiationData.ApprovalRequestNotes;
            }
            else
            {
                this.ApprovalTaskProperties.Description = "Please approve the current offer";
            }

            this.ApprovalTaskProperties.DueDate = DateTime.Now.AddDays(10);
            this.ApprovalTaskProperties.SendEmailNotification = true;
            this.ApprovalTaskProperties.Title = String.Format("Please approve offer {0}", this.workflowProperties.Item.Title);
        }

        public static DependencyProperty OfferToCRMProperty = DependencyProperty.Register("OfferToCRM", typeof(DevLeap.SP2010.ExternalCRMService.Offer), typeof(DevLeap.SP2010.CRMOffersApproval.CRMOffersApprovalWorkflow.CRMOffersApprovalWorkflow));

        [DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)]
        [BrowsableAttribute(true)]
        [CategoryAttribute("Misc")]
        public ExternalCRMService.Offer OfferToCRM
        {
            get
            {
                return ((DevLeap.SP2010.ExternalCRMService.Offer)(base.GetValue(DevLeap.SP2010.CRMOffersApproval.CRMOffersApprovalWorkflow.CRMOffersApprovalWorkflow.OfferToCRMProperty)));
            }
            set
            {
                base.SetValue(DevLeap.SP2010.CRMOffersApproval.CRMOffersApprovalWorkflow.CRMOffersApprovalWorkflow.OfferToCRMProperty, value);
            }
        }

        private void submitOfferToCRM_MethodInvoking(object sender, EventArgs e)
        {
            this.OfferToCRM = new ExternalCRMService.Offer();
            this.OfferToCRM.EuroAmount = (Decimal)((Double)this.workflowProperties.Item[FieldsIds.DevLeapCRMOfferEuroAmount_Id]);
            this.OfferToCRM.SharePointCode = (String)this.workflowProperties.Item[FieldsIds.DevLeapCRMOfferCode_Id];
        }

        public static DependencyProperty CRMCodeProperty = DependencyProperty.Register("CRMCode", typeof(System.String), typeof(DevLeap.SP2010.CRMOffersApproval.CRMOffersApprovalWorkflow.CRMOffersApprovalWorkflow));

        [DesignerSerializationVisibilityAttribute(DesignerSerializationVisibility.Visible)]
        [BrowsableAttribute(true)]
        [CategoryAttribute("Misc")]
        public String CRMCode
        {
            get
            {
                return ((string)(base.GetValue(DevLeap.SP2010.CRMOffersApproval.CRMOffersApprovalWorkflow.CRMOffersApprovalWorkflow.CRMCodeProperty)));
            }
            set
            {
                base.SetValue(DevLeap.SP2010.CRMOffersApproval.CRMOffersApprovalWorkflow.CRMOffersApprovalWorkflow.CRMCodeProperty, value);
            }
        }

        private void CodeAvailableFromCRM_Invoked(object sender, ExternalDataEventArgs e)
        {
            this.workflowProperties.Item[FieldsIds.DevLeapCRMExternalCode_Id] =
                this.CRMCode;
            this.workflowProperties.Item.SystemUpdate();
        }
    }
}
