﻿using System;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using Microsoft.SharePoint.Workflow;
using System.Web.UI.WebControls;
using System.Collections;
using Microsoft.SharePoint.Utilities;
using System.Web;

namespace DevLeap.SP2010.CRMOffersApproval.Layouts.DevLeap.SP2010.CRMOffersApproval
{
    public partial class CRMOfferApprovalTaskForm : LayoutsPageBase
    {
        protected SPList targetTasksList;
        SPListItem targetTask;
        protected SPWorkflow workflowInstance;

        protected void Page_Load(object sender, EventArgs e)
        {
            // Retrieve the current task list and task item
            targetTasksList = Web.Lists[new Guid(Request.Params["List"])];
            targetTask = targetTasksList.GetItemById(int.Parse(Request.Params["ID"]));

            if (!this.Page.IsPostBack)
            {
                // Populate fields on the form
                this.DevLeapApprovalTaskDescription.Text = targetTask[FieldsIds.DevLeapCRMApprovalTaskDescription_Id] != null ? targetTask[FieldsIds.DevLeapCRMApprovalTaskDescription_Id].ToString() : String.Empty;
                this.DevLeapApprovalTaskNotes.Text = targetTask[FieldsIds.DevLeapCRMApprovalTaskNotes_Id] != null ? targetTask[FieldsIds.DevLeapCRMApprovalTaskNotes_Id].ToString() : String.Empty;
                ListItem outcomeToSelect = this.DevLeapApprovalTaskOutcome.Items.FindByValue(targetTask[FieldsIds.DevLeapCRMApprovalTaskOutcome_Id].ToString());
                if (outcomeToSelect != null)
                {
                    this.DevLeapApprovalTaskOutcome.ClearSelection();
                    outcomeToSelect.Selected = true;
                }
            }
        }

        protected void UpdateTaskFromControls(SPListItem targetTask, System.Collections.Hashtable taskProperties)
        {
            // Update task item fields
            taskProperties[FieldsIds.DevLeapCRMApprovalTaskStatus_Id] = "Completed";
            taskProperties[FieldsIds.DevLeapCRMApprovalTaskNotes_Id] = this.DevLeapApprovalTaskNotes.Text;
            taskProperties[FieldsIds.DevLeapCRMApprovalTaskOutcome_Id] = this.DevLeapApprovalTaskOutcome.SelectedValue;
        }

        #region Infrastructural code

        protected void SaveApprovalTask_Click(object sender, EventArgs e)
        {
            try
            {
                Hashtable taskProperties = new Hashtable();
                UpdateTaskFromControls(targetTask, taskProperties);
                SPWorkflowTask.AlterTask(targetTask, taskProperties, false);
            }

            catch (Exception exception)
            {
                SPUtility.Redirect("Error.aspx", SPRedirectFlags.RelativeToLayoutsPage,
                                   HttpContext.Current,
                   "ErrorText=" + SPHttpUtility.UrlKeyValueEncode(exception.Message));
            }

            ClosePopup();
        }

        protected void Cancel_Click(object sender, EventArgs e)
        {
            ClosePopup();
        }

        private void ClosePopup()
        {
            this.Response.Clear();
            this.Response.Write("<html><body>Closing ...<script type='text/javascript'>window.frameElement.commitPopup();</script></body></html>");
            this.Response.Flush();
            this.Response.End();
        }

        #endregion

    }
}
