﻿using System;
using System.ComponentModel;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using Microsoft.IdentityModel.Claims;

namespace DevLeap.SP2010.AuthDemos.ShowCurrentUserWebPart
{
    [ToolboxItemAttribute(false)]
    public class ShowCurrentUserWebPart : WebPart
    {
        protected override void CreateChildControls()
        {
            if (SPContext.Current.Web.CurrentUser != null)
            {
                this.Controls.Add(new LiteralControl(
                    String.Format("<div>SPUser.Name: {0}</div>",
                    SPContext.Current.Web.CurrentUser.Name)));

                this.Controls.Add(new LiteralControl(
                    String.Format("<div>SPUser.LoginName: {0}</div>",
                    SPContext.Current.Web.CurrentUser.LoginName)));
            }

            if (this.Page.User != null)
            {
                this.Controls.Add(new LiteralControl(
                    String.Format("<div>Identity IsAuthenticated: {0}</div>",
                    this.Page.User.Identity.IsAuthenticated)));

                this.Controls.Add(new LiteralControl(
                    String.Format("<div>Identity.Name: {0}</div>",
                    this.Page.User.Identity.Name)));

                this.Controls.Add(new LiteralControl(
                    String.Format("<div>Identity AuthenticationType: {0}</div>",
                    this.Page.User.Identity.AuthenticationType)));

                this.Controls.Add(new LiteralControl(
                    String.Format("<div>Identity Type: {0}</div>",
                    this.Page.User.Identity.GetType().Name)));

                this.Controls.Add(new LiteralControl(
                    String.Format("<div>Principal Type: {0}</div>",
                    this.Page.User.GetType().Name)));

                ClaimsIdentity ci = this.Page.User.Identity as ClaimsIdentity;
                if (ci != null)
                {
                    this.Controls.Add(new LiteralControl("<h2>Claims</h2>"));

                    foreach (var c in ci.Claims)
                    {
                        this.Controls.Add(new LiteralControl(
                            String.Format("<div>ClaimType: {0} - ClaimValue: {1} - ClaimValueType: {2}</div>",
                            c.ClaimType, c.Value, c.ValueType)));
                    }
                }
            }
        }
    }
}
