using System;
using System.Runtime.InteropServices;
using System.Security.Permissions;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Security;
using Microsoft.SharePoint.Administration;
using Microsoft.SharePoint.UserCode;

namespace DevLeap.SP2010.SandboxValidator.Features.SandboxValidatorFeature
{
    /// <summary>
    /// This class handles events raised during feature activation, deactivation, installation, uninstallation, and upgrade.
    /// </summary>
    /// <remarks>
    /// The GUID attached to this class may be used during packaging and should not be modified.
    /// </remarks>

    [Guid("19dfd704-461a-48ec-a7f4-0411354b56e6")]
    public class SandboxValidatorFeatureEventReceiver : SPFeatureReceiver
    {
        public override void FeatureActivated(SPFeatureReceiverProperties properties)
        {
            SPUserCodeService userCodeService = SPUserCodeService.Local;
            if (userCodeService != null)
            {
                SPSolutionValidator validator = new DevLeapSolutionValidator(userCodeService);
                userCodeService.SolutionValidators.Add(validator);
            }
        }

        public override void FeatureDeactivating(SPFeatureReceiverProperties properties)
        {
            SPUserCodeService userCodeService = SPUserCodeService.Local;
            if (userCodeService != null)
            {
                SPSolutionValidator validator = new DevLeapSolutionValidator(userCodeService);
                userCodeService.SolutionValidators.Remove(validator.Id);
            }
        }
    }
}
