﻿using System;
using System.ComponentModel;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using System.Collections.Generic;

namespace DevLeap.SP2010.SandboxedWebPart
{
    [ToolboxItemAttribute(false)]
    public class ListOfItems: WebPart
    {
        [WebBrowsable(true)]
        [Personalizable(PersonalizationScope.Shared)]
        [WebDescription("Title of the Source list")]
        [WebDisplayName("Source list")]
        [Category("Data Foundation")]
        public String SourceListTitle { get; set; }

        protected GridView grid;

        protected override void CreateChildControls()
        {
            if (!String.IsNullOrEmpty(this.SourceListTitle))
            {
                SPWeb web = SPContext.Current.Web;
                SPList sourceList = web.Lists[this.SourceListTitle];

                this.grid = new GridView();
                this.Controls.Add(grid);

                List<String> listItemsTitles = new List<string>();

                foreach (SPListItem item in sourceList.Items)
                {
                    listItemsTitles.Add(item.Title);
                }

                this.grid.DataSource = listItemsTitles;
                this.grid.DataBind();
            }
            else
            {
                this.Controls.Add(new LiteralControl("Please configure this Web Part"));
            }
        }
    }
}
