﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.SharePoint.UserCode;
using System.Data;
using System.Data.SqlClient;

namespace DevLeap.SP2010.FullTrustProxy
{
    [Serializable]
    public class RetrieveNWindCustomersArgs : SPProxyOperationArgs
    {
        public String SqlConnectionString { get; set; }
    }

    public class RetrieveNWindCustomers : SPProxyOperation 
    {
        public override object Execute(SPProxyOperationArgs args)
        {
            // Prepare a variable to host the result
            DataSet result = null;
            
            // Check if the args parameter is of custom type
            RetrieveNWindCustomersArgs typedArgs = args as RetrieveNWindCustomersArgs;
            if (args != null)
            { 
                // In case args is of the right type
                using (SqlConnection cn = new SqlConnection(typedArgs.SqlConnectionString))
                {
                    using (SqlDataAdapter da = new SqlDataAdapter("SELECT * FROM Customers", cn))
                    {
                        result = new DataSet();
                        da.Fill(result);
                    }
                }
            }

            return result;
        }
    }
}
