﻿using System;
using System.ComponentModel;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using Microsoft.SharePoint.Utilities;
using System.Reflection;
using DevLeap.SP2010.FullTrustProxy;
using System.Data;

namespace DevLeap.SP2010.WebPartWithProxy
{
    [ToolboxItemAttribute(false)]
    public class ShowNWindCustomers : WebPart
    {
        protected GridView gridCustomers;

        [WebBrowsable(true)]
        [Personalizable(true)]
        public String SqlConnectionString { get; set; }

        protected override void CreateChildControls()
        {
            // In case the Web Part is configured
            if (!String.IsNullOrEmpty(this.SqlConnectionString))
            {
                // Prepare the custom argument
                RetrieveNWindCustomersArgs args =
                    new RetrieveNWindCustomersArgs() { 
                        SqlConnectionString = this.SqlConnectionString,
                    };

                // Invoke the proxy operation
                DataSet data = SPUtility.ExecuteRegisteredProxyOperation(
                    typeof(RetrieveNWindCustomers).Assembly.FullName,
                    typeof(RetrieveNWindCustomers).FullName,
                    args) as DataSet;

                // In case there is data in the result
                if (data != null)
                {
                    this.gridCustomers = new GridView();
                    this.Controls.Add(this.gridCustomers);

                    this.gridCustomers.DataSource = data;
                    this.gridCustomers.DataBind();
                }
                else
                {
                    this.Controls.Add(new LiteralControl("Invalid result from remote proxy."));
                }
            }
            else
            {
                this.Controls.Add(new LiteralControl("Please configure the SQL Connection String."));
            }
        }
    }
}
