﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;
using System.ServiceModel.Activation;
using System.ServiceModel.Syndication;

[AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
public class DevLeapFeedService : IDevLeapFeedService
{
    public SyndicationFeedFormatter GetFeed(String searchTerm, String feedType)
    {
        SyndicationFeed feed = new SyndicationFeed("DevLeap Sample Feed", String.Format("All blog posts of {0}!", searchTerm), new Uri("http://blogs.devleap.com/Feed/"));
        feed.Authors.Add(new SyndicationPerson("info@devleap.com"));
        feed.Categories.Add(new SyndicationCategory("Miscellanea"));
        feed.Description = new TextSyndicationContent("This is a sample feed to define e Federated Location in SharePoint 2010");

        List<SyndicationItem> items = new List<SyndicationItem>();

        items.AddRange(
            from i in Enumerable.Range(1, 30)
            let id = Guid.NewGuid().ToString()
            select new SyndicationItem(
            String.Format("Title {0}", i),
            new TextSyndicationContent(String.Format("Lorem ipsum dolor sit amet, {0} consectetur adipisici elit, sed eiusmod tempor incidunt ut labore et dolore {0} magna aliqua. Ut enim ad minim veniam, quis nostrud {0} exercitation ullamco laboris nisi ut aliquid ex ea commodi consequat. Quis aute iure reprehenderit in {0} voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint obcaecat cupiditat non proident, sunt in culpa qui officia {0} deserunt mollit anim id est laborum.", searchTerm), TextSyndicationContentKind.Plaintext),
            new Uri("http://blogs.devleap.com/Feed/" + id),
            id,
            DateTimeOffset.Now));

        feed.Items = items;

        if (feedType.ToLower() == "rss")
        {
            return new Rss20FeedFormatter(feed);
        }
        else if (feedType.ToLower() == "atom")
        {
            return new Atom10FeedFormatter(feed);
        }
        else
        {
            return null;
        }
    }
}
