﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Xml.Linq;
using System.Net;
using DevLeap.SP2010.Search.SOAPConsumer.SearchServiceReference;

namespace DevLeap.SP2010.Search.SOAPConsumer
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void searchButton_Click(object sender, RoutedEventArgs e)
        {
            QueryService search = new QueryService();
            search.Credentials = System.Net.CredentialCache.DefaultCredentials;
            search.Url = targetUrl.Text +
                (targetUrl.Text.EndsWith("/") ? String.Empty : "/") +
                "_vti_bin/search.asmx";

            XElement queryXml = XElement.Load(@"..\..\QueryPacket.xml");

            XNamespace nsRequest = "urn:Microsoft.Search.Query";
            XNode queryTextNode = queryXml.Descendants(nsRequest + "QueryText").FirstOrDefault();

            if (queryTextNode != null)
            {
                XElement queryTextElement = queryTextNode as XElement;
                queryTextElement.SetValue(searchBox.Text);
                queryTextElement.Attribute("type").Value = "STRING";

                String xmlResultsText = search.Query(queryXml.ToString());

                XNamespace nsResponse = "urn:Microsoft.Search.Response";
                XNamespace nsDocument = "urn:Microsoft.Search.Response.Document";

                XElement xmlResults = XElement.Parse(xmlResultsText);
                results.DataContext =
                    from r in xmlResults.Descendants(nsDocument + "Title")
                    select r;
            }
        }
    }
}
