﻿using System;
using System.ComponentModel;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using Microsoft.Office.Server.Search.WebControls;
using Microsoft.Office.Server.Search.Query;
using System.Text;
using System.Xml.XPath;

namespace DevLeap.SP2010.Search.WebParts.DevLeapCoreResultsWebPart
{
    [ToolboxItemAttribute(false)]
    public class DevLeapCoreResultsWebPart : CoreResultsWebPart
    {
        protected override void ModifyXsltArgumentList(Microsoft.SharePoint.WebPartPages.ArgumentClassWrapper argList)
        {
            // Invoke the base implementation
            base.ModifyXsltArgumentList(argList);

            // Add a parameter with the current user name
            String currentUserName = SPContext.Current.Web.CurrentUser.Name;
            argList.AddParameter("CurrentUserName", String.Empty, currentUserName);
        }

        protected override void CreateChildControls()
        {
            base.CreateChildControls();

            // Get a reference to the current QueryManager
            QueryManager qm = SharedQueryManager.GetInstance(this.Page).QueryManager;

            // Get a reference to the first LocationList
            LocationList locationList = qm[0];

            // Get a reference to the first location
            Location location = locationList[0];

            // Retrieve an XPathNavigator on the results
            XPathNavigator locationNavigator = location.Result.CreateNavigator();
            XPathNodeIterator results = locationNavigator.Select("All_Results/Result");

            // For each Result element
            foreach (XPathNavigator result in results)
            {
                // Extract the title child node
                this.Controls.Add(new LiteralControl(String.Format("<div>{0}</div>",
                    result.SelectSingleNode("title"))));
            }
        }
    }
}
