﻿<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:msxsl="urn:schemas-microsoft-com:xslt" exclude-result-prefixes="msxsl">

  <xsl:output method="xml" indent="yes"/>

  <xsl:param name="Keyword" />
  <xsl:param name="IsDesignMode">True</xsl:param>
  <xsl:param name="ShowMessage" />
  <xsl:param name="ResultsNotFound" />

  <xsl:template match="/All_Results">
    <xsl:if test="$IsDesignMode = 'False'">
      <xsl:choose>
        <xsl:when test="$ShowMessage = 'True'">
          <div>
            <xsl:value-of select="$ResultsNotFound" />
            <xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
            <strong>
              <xsl:value-of select="$Keyword" />
            </strong>
          </div>
        </xsl:when>
        <xsl:otherwise>
          <div>
            <xsl:for-each select="Result">
              <div>
                <xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;</xsl:text>
                <a href="{url}">
                  <img src="{imageurl}" border="0" />
                  <xsl:text disable-output-escaping="yes">&amp;nbsp;&amp;nbsp;</xsl:text>
                  <xsl:value-of select="title" />
                </a>
              </div>
            </xsl:for-each>
          </div>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:if>
    <xsl:if test="$IsDesignMode = 'True'">
      <div>Design mode ...</div>
    </xsl:if>
  </xsl:template>

</xsl:stylesheet>
