﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DevLeap.SP2010.ModelSampleCRM;
using DevLeap.SP2010;

namespace DevLeap.SP2010.ModelSampleCRM.DevLeapSampleCRM
{
    public partial class CustomerService
    {
        private static SampleCRMDataContext GetDataContext()
        {
            SampleCRMDataContext dc = new SampleCRMDataContext(@"server=SP2010DEV\SQLEXPRESS;database=SampleCRM;integrated security=SSPI;");
            return dc;
        }

        public static IEnumerable<Customer> ReadList()
        {
            SampleCRMDataContext dc = GetDataContext();

            return (from c in dc.Customers
                    select c);
        }

        public static Customer ReadItem(string customerID)
        {
            SampleCRMDataContext dc = GetDataContext();

            return (dc.Customers
                .FirstOrDefault(c => c.CustomerID == customerID));
        }

        public static Customer Create(Customer newCustomer)
        {
            SampleCRMDataContext dc = GetDataContext();

            dc.Customers.InsertOnSubmit(newCustomer);
            dc.SubmitChanges();

            return (newCustomer);
        }

        public static void Update(Customer customer, string customerID)
        {
            SampleCRMDataContext dc = GetDataContext();

            dc.Customers.Attach(customer, true);
            dc.SubmitChanges();
        }

        public static void Delete(string customerID)
        {
            SampleCRMDataContext dc = GetDataContext();

            Customer customerToDelete = dc.Customers
                .FirstOrDefault(c => c.CustomerID == customerID);

            dc.Customers.DeleteOnSubmit(customerToDelete);
            dc.SubmitChanges();
        }
    }
}
